function [k theta  rhotd omegatd scaling] = FB(trce,trceTime)
%%%%%% EM algorithm %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%Loop through all entries in the time list
%%% Mark them as lost, received or missed
%%% iterate through all the missed entries
%%% compute the likelihood for each possible outcome
%%% using the  modified backward and forward algorithm

clear k theta kold thetaold L NL binArray timeArray P rhotd alpha limit scaling omegatd beta 

%%innitialize
[L NL]= LNL(trce);
EL=mean(L);
ENL=mean(NL);
%%%innitialize
k=[20 1];
if (var(L)>0)
    k(1)=EL^2/(var(L));
end
if (var(NL)>0)
    k(2)=ENL^2/(var(NL));
end

%%%%%%k
theta=[EL/k(1) ENL/k(2)];


%Infer lambda from trceTime
diff=[];
for i=1:min(2000,length(trceTime))-1
    diff=[diff (trceTime(i+1)-trceTime(i))];
end
si = mean(diff);
lambda=1/si;

%%%% Discretization interval
timeInt =EL/lambda/4;%lambda/4;%%%TODO: What is the optimal value?


%%%% Dmax: the maximum length of the support
rLim = 1000; %%% TODO: what is the optimal value?

n_samples=length(trce);
maxTime=trceTime(length(trceTime))-trceTime(1);
timeArray = trceTime(1) + [0:timeInt:(maxTime+timeInt)];

%%% Limit the size of the array for memory consumption
timeArray=timeArray(1:min(40000,length(timeArray)));

D=4000;
B=[1-exp(-lambda*timeInt) 0 exp(-lambda*timeInt);0 1-exp(-lambda*timeInt) exp(-lambda*timeInt)]; %%% 3 is unobserved; 1 is loss, 2 is good


binArray=(-1)*ones(1,length(timeArray));
for t=2:length(timeArray)
    tempk=find((trceTime>=timeArray(t-1))&(trceTime<timeArray(t)));
    if length(tempk)>0
        binArray(t) = trce(tempk(1));
    end
end
%%%% Forward and backward algotihm


P=zeros(2,D);
for i=1:2
    for j=1:D
        P(i,j) =  distF(theta(i),k(i),j);
    end
end


iterNr=0;
maxIter=60;

likelihood = -1;%log(sum(alpha(:,length(timeArray))));
likelihoodold=-10;
piArray=[0.5 0.5];

kold=[0 0];
thetaold=[0 0];


%%% stopping criteria
%while ((abs(theta(1)-thetaold(1))>0.000001*theta(1))|| (abs(theta(2)-thetaold(2))>0.00001*theta(2)))&&((likelihood-likelihoodold>0.00001*abs(likelihoodold))||(iterNr<2))
while ((likelihood-likelihoodold>0.00001*abs(likelihoodold))||(iterNr==1))&&(iterNr<maxIter)
%while (iterNr<100)    
    clear  rhotd alpha limit scaling omegatd beta  

    tic
    iterNr=iterNr+1
    
    thetaold=theta;
    kold=k;
       
    P=zeros(2,D);
    for i=1:2
        for j=1:D
            P(i,j) =  distF(theta(i),k(i),j);
        end
    end
    
    
    likelihoodold=likelihood;
    
    alpha=ones(2,length(timeArray)+1);
    
    %%%% How many look-ahead should I do
    %%%% for each time point
    limit =zeros(2,length(timeArray));
    
    %%%Rho
    rhotd=zeros(2,length(timeArray)+1, rLim);
    rhotd(1,1,1)=mean(L)/(mean(L)+mean(NL));
    rhotd(2,1,1)=mean(NL)/(mean(L)+mean(NL));
    
    scaling =ones(1,length(timeArray));
    
    for i=2:size(rhotd,2)
        alpha(1,i)= 0;
        alpha(2,i)= 0;
     
        %%%%scaling        
        if (binArray(i-1)>=0)&&(sum(alpha(:,i-1))>0)
            scaling(i-1) = 1/sum(alpha(:,i-1));
        end
        
        if binArray(i-1) == 0
            for j=2:min(i,rLim)
                rhotd(1,i,j)= scaling(i-1)*rhotd(1,i-1,j-1)*B(1,1);
                alpha(1,i) = alpha(1,i)+rhotd(1,i,j)*P(1,j-1);
                if i>j
                    if isequal(binArray((i-1) - (j-1)),1)
                        break
                    end
                end
                
            end
        elseif binArray(i-1) == 1
            for j=2:min(i,rLim)
                rhotd(2,i,j)= scaling(i-1)*rhotd(2,i-1,j-1)*B(2,2);
                alpha(2,i) = alpha(2,i)+rhotd(2,i,j)*P(2,j-1);
                if i>j
                    if isequal(binArray((i-1) - (j-1)),0)
                        break
                    end
                end
            end
        else
            for idx=1:1:2
                if idx ==1
                    for j=2:i
                        rhotd(1,i,j)= scaling(i-1)*rhotd(1,i-1,j-1)*B(1,3);
                        alpha(1,i) = alpha(1,i)+rhotd(1,i,j)*P(1,j-1);
                        if i>j
                            if isequal(binArray((i-1) - (j-1)),1)
                                break
                            end
                        end
                    end
                else
                    for j=2:min(i,rLim)
                        rhotd(2,i,j)= scaling(i-1)*rhotd(2,i-1,j-1)*B(1,3);
                        alpha(2,i) = alpha(2,i)+rhotd(2,i,j)*P(2,j-1);
                        if i>j
                            if isequal(binArray((i-1) - (j-1)),0)
                                break
                            end
                        end
                    end
                end
            end
        end
        rhotd(1,i,1)=alpha(2,i);
        rhotd(2,i,1)=alpha(1,i);
    end
    
    %%omega
    omegatd=zeros(2,length(timeArray)+1,rLim);
    omegatd(:,length(timeArray)+1,1)=1;
    beta = ones(2,length(timeArray)+1);
    for i=2:size(rhotd,2)
        iinv=length(timeArray)+2 -i;
        beta(1,iinv)=0;
        beta(2,iinv)=0;
        if binArray(iinv) == 0
            for j=2:min(iinv,rLim)%length(timeArray)
                omegatd(1,iinv,j)= scaling(iinv)*omegatd(1,iinv+1,j-1)*B(1,1); %%%% Be very careful here!!!! scaling(iinv) or scaling(iinv+1)
                beta(1,iinv) = beta(1,iinv)+omegatd(1,iinv,j)*P(1,j-1); %%% theta,k,n
                if iinv + j-1 <= length(timeArray)
                    if isequal(binArray((iinv) + (j-1)),1)
                        break
                    end
                else
                    break
                end
            end
            limit(1,iinv) = j;
            
        elseif binArray(iinv) == 1
            for j=2:min(iinv,rLim)
                omegatd(2,iinv,j)= scaling(iinv)*omegatd(2,iinv+1,j-1)*B(2,2);
                beta(2,iinv) = beta(2,iinv)+omegatd(2,iinv,j)*P(2,j-1);
                if iinv + j-1 <= length(timeArray)
                    if isequal(binArray((iinv) + (j-1)),0)
                        break
                    end
                else
                    break
                end
            end
            limit(2,iinv) = j;
        else
            %%%%% How much should I travel back in time 
            for idx=1:2
                if idx == 1
                    for j=2:rLim
                        omegatd(1,iinv,j)= scaling(iinv)*omegatd(1,iinv+1,j-1)*B(1,3);
                        beta(1,iinv) = beta(1,iinv)+omegatd(1,iinv,j)*P(1,j-1);
                        
                        if iinv + j -1<= length(timeArray)
                            if isequal(binArray((iinv) + (j-1)),1)
                                break
                            end
                        else
                            break
                        end
                    end
                    
                    limit(1,iinv) = j;
                   
                else
                    
                    for j=2:rLim
                        omegatd(2,iinv,j)= scaling(iinv)*omegatd(2,iinv+1,j-1)*B(2,3);
                        beta(2,iinv) = beta(2,iinv)+omegatd(2,iinv,j)*P(2,j-1);
                        if iinv + j -1 <= length(timeArray)
                            if isequal(binArray((iinv) + (j-1)),0)
                                break
                            end
                        else
                            break
                        end
                    end
                    limit(2,iinv) = j;
                end
            end
        end
        omegatd(1,iinv,1)=beta(2,iinv);
        omegatd(2,iinv,1)=beta(1,iinv);
    end
  
    nume1=0;
    deno1=0;
    deno2=0;
    nume2=0;
    numek1=0;
    denok1=0;
    denok2=0;
    numek2=0;
    
    for i=3:size(omegatd,2)+1 
        for idx=1:1:2
            if idx ==1
                for j=2:limit(1,i-2)
                    nume1=nume1+(j-1)*rhotd(1,i-2,1)*P(1,j-1)*omegatd(1,i-2,j);
                    numek1=numek1+log((j-1)/theta(1))*rhotd(1,i-2,1)*P(1,j-1)*omegatd(1,i-2,j);
                    deno1 = deno1 +rhotd(1,i-2,1)*P(1,j-1)*omegatd(1,i-2,j);
                end
            else
                for j=2:limit(2,i-2)
                    nume2=nume2+(j-1)*rhotd(2,i-2,1)*P(2,j-1)*omegatd(2,i-2,j);
                    numek2=numek2+ log((j-1)/theta(2))*rhotd(2,i-2,1)*P(2,j-1)*omegatd(2,i-2,j);
                    deno2 = deno2+ rhotd(2,i-2,1)*P(2,j-1)*omegatd(2,i-2,j);
                end
            end
        end
        
        denok1=deno1;
        denok2=deno2;
    end
    
    [k]= NR(numek1,denok1,numek2,denok2)  % Calling Newton_Raphson
    
        
    theta(1)= nume1/(k(1)*deno1);
    theta(2)= nume2/(k(2)*deno2);
  
    %likelihood = log(sum(alpha(:,length(timeArray))))
    likelihood = -sum(log(scaling)) %%%%% 
    toc
end

%%%% Adjusting for the timeInt scale
theta=timeInt*theta;

